﻿Imports System.IO

Module mdlConfig
    Public Sub SetUpConfig()
        Dim CurrentNum As MyConfig
        'Colors
        CurrentNum = MyConfig.ForegroundColor
        ConfigName(CurrentNum) = "Foreground Color"
        ConfigShow(CurrentNum, 0, ConfigType.Value) = Hex(Color.White.R).PadLeft(2, "0") & Hex(Color.White.G).PadLeft(2, "0") & Hex(Color.White.B).PadLeft(2, "0")
        ConfigShow(CurrentNum, 0, ConfigType.Text) = "White(Standard)"
        ConfigShow(CurrentNum, 1, ConfigType.Value) = Hex(Color.Black.R).PadLeft(2, "0") & Hex(Color.Black.G).PadLeft(2, "0") & Hex(Color.Black.B).PadLeft(2, "0")
        ConfigShow(CurrentNum, 1, ConfigType.Text) = "Black"
        ConfigShow(CurrentNum, 2, ConfigType.Value) = "custom"
        ConfigShow(CurrentNum, 2, ConfigType.Text) = "Custom(Hex)"
        ConfigMax(CurrentNum) = 2

        CurrentNum = MyConfig.BackgroundColor
        ConfigName(CurrentNum) = "Background Color"
        ConfigShow(CurrentNum, 0, ConfigType.Value) = Hex(Color.Black.R).PadLeft(2, "0") & Hex(Color.Black.G).PadLeft(2, "0") & Hex(Color.Black.B).PadLeft(2, "0")
        ConfigShow(CurrentNum, 0, ConfigType.Text) = "Black(Standard)"
        ConfigShow(CurrentNum, 1, ConfigType.Value) = Hex(Color.White.R).PadLeft(2, "0") & Hex(Color.White.G).PadLeft(2, "0") & Hex(Color.White.B).PadLeft(2, "0")
        ConfigShow(CurrentNum, 1, ConfigType.Text) = "White"
        ConfigShow(CurrentNum, 2, ConfigType.Value) = "custom"
        ConfigShow(CurrentNum, 2, ConfigType.Text) = "Custom(Hex)"
        ConfigMax(CurrentNum) = 2

        'Units
        CurrentNum = MyConfig.MetricsUnit
        ConfigName(CurrentNum) = "Metrics Unit"
        ConfigShow(CurrentNum, 0, ConfigType.Value) = "km"
        ConfigShow(CurrentNum, 0, ConfigType.Text) = "Kilometers(km)"
        ConfigShow(CurrentNum, 1, ConfigType.Value) = "m"
        ConfigShow(CurrentNum, 1, ConfigType.Text) = "Miles(m)"
        ConfigShow(CurrentNum, 2, ConfigType.Value) = "custom"
        ConfigShow(CurrentNum, 2, ConfigType.Text) = "Custom"
        ConfigMax(CurrentNum) = 2

        CurrentNum = MyConfig.FuelAmountUnit
        ConfigName(CurrentNum) = "Fuel Unit"
        ConfigShow(CurrentNum, 0, ConfigType.Value) = "l"
        ConfigShow(CurrentNum, 0, ConfigType.Text) = "Liters(l)"
        ConfigShow(CurrentNum, 1, ConfigType.Value) = "gal"
        ConfigShow(CurrentNum, 1, ConfigType.Text) = "Gallons(gal)"
        ConfigShow(CurrentNum, 2, ConfigType.Value) = "custom"
        ConfigShow(CurrentNum, 2, ConfigType.Text) = "Custom"
        ConfigMax(CurrentNum) = 2

        CurrentNum = MyConfig.CurrencyUnit
        ConfigName(MyConfig.CurrencyUnit) = "Currency"
        ConfigShow(CurrentNum, 0, ConfigType.Value) = "€"
        ConfigShow(CurrentNum, 0, ConfigType.Text) = "Euro(€)"
        ConfigShow(CurrentNum, 1, ConfigType.Value) = "£"
        ConfigShow(CurrentNum, 1, ConfigType.Text) = "Pounds(£)"
        ConfigShow(CurrentNum, 2, ConfigType.Value) = "$"
        ConfigShow(CurrentNum, 2, ConfigType.Text) = "Dollar($)"
        ConfigShow(CurrentNum, 3, ConfigType.Value) = "custom"
        ConfigShow(CurrentNum, 3, ConfigType.Text) = "Custom"
        ConfigMax(CurrentNum) = 3

        'Screen
        CurrentNum = MyConfig.ScreenMultiplicator
        ConfigName(CurrentNum) = "Screen Multiplicator"
        ConfigShow(CurrentNum, 0, ConfigType.Value) = "1"
        ConfigShow(CurrentNum, 0, ConfigType.Text) = "QVGA(1)"
        ConfigShow(CurrentNum, 1, ConfigType.Value) = "2"
        ConfigShow(CurrentNum, 1, ConfigType.Text) = "VGA(2)"
        ConfigShow(CurrentNum, 2, ConfigType.Value) = "custom"
        ConfigShow(CurrentNum, 2, ConfigType.Text) = "Custom"
        ConfigMax(CurrentNum) = 2

        CurrentNum = MyConfig.FontSize
        ConfigName(CurrentNum) = "Font Size"
        ConfigShow(CurrentNum, 0, ConfigType.Value) = "8"
        ConfigShow(CurrentNum, 0, ConfigType.Text) = "8px (for QVGA)"
        ConfigShow(CurrentNum, 1, ConfigType.Value) = "7"
        ConfigShow(CurrentNum, 1, ConfigType.Text) = "7px (for VGA)"
        ConfigShow(CurrentNum, 2, ConfigType.Value) = "custom"
        ConfigShow(CurrentNum, 2, ConfigType.Text) = "Custom"
        ConfigMax(CurrentNum) = 2

        'Various
        CurrentNum = MyConfig.DistanceAddType
        ConfigName(CurrentNum) = "Distance Add Type"
        ConfigShow(CurrentNum, 0, ConfigType.Value) = "trip"
        ConfigShow(CurrentNum, 0, ConfigType.Text) = "Per Trip"
        ConfigShow(CurrentNum, 1, ConfigType.Value) = "total"
        ConfigShow(CurrentNum, 1, ConfigType.Text) = "Total"
        ConfigMax(CurrentNum) = 1

        CurrentNum = MyConfig.DistanceStart
        ConfigName(CurrentNum) = "Your odometer at first use."
        ConfigShow(CurrentNum, 0, ConfigType.Value) = "custom"
        ConfigShow(CurrentNum, 0, ConfigType.Text) = "First use at"
        ConfigMax(CurrentNum) = 0

        CurrentNum = MyConfig.LastGraphType
        ConfigName(CurrentNum) = "Last Graphs' Type"
        ConfigShow(CurrentNum, 0, ConfigType.Value) = "lp100"
        ConfigShow(CurrentNum, 0, ConfigType.Text) = "l/100km-Style"
        ConfigShow(CurrentNum, 1, ConfigType.Value) = "mpg"
        ConfigShow(CurrentNum, 1, ConfigType.Text) = "MPG-Style"
        ConfigMax(CurrentNum) = 1

        CurrentNum = MyConfig.TapTime
        ConfigName(CurrentNum) = "Double Tap Time"
        ConfigShow(CurrentNum, 0, ConfigType.Value) = "2000"
        ConfigShow(CurrentNum, 0, ConfigType.Text) = "2000ms"
        ConfigShow(CurrentNum, 1, ConfigType.Value) = "1000"
        ConfigShow(CurrentNum, 1, ConfigType.Text) = "1000ms"
        ConfigShow(CurrentNum, 2, ConfigType.Value) = "custom"
        ConfigShow(CurrentNum, 2, ConfigType.Text) = "Custom (in ms)"
        ConfigMax(CurrentNum) = 2

        'Icon Set
        CurrentNum = MyConfig.IconSet
        ConfigName(CurrentNum) = "Menu Icon Set"
        ConfigShow(CurrentNum, 0, ConfigType.Value) = "Blue Letter"
        ConfigShow(CurrentNum, 0, ConfigType.Text) = "SciLor's Blue Letter"
        ConfigShow(CurrentNum, 1, ConfigType.Value) = "Black"
        ConfigShow(CurrentNum, 1, ConfigType.Text) = "G.Brizgys's Black"
        ConfigMax(CurrentNum) = 1

        Dim Root As New DirectoryInfo(AppPath & "\gfx")
        Dim Dirs As DirectoryInfo() = Root.GetDirectories()
        Dim DirectoryName As DirectoryInfo
        Dim TextMax As Byte = ConfigMax(CurrentNum)
        Dim isNew As Boolean = True
        For Each DirectoryName In Dirs
            For I = 0 To TextMax
                If ConfigShow(CurrentNum, I, ConfigType.Value) = DirectoryName.Name Then
                    isNew = False
                End If
            Next
            If isNew = True Then
                ConfigMax(CurrentNum) += 1
                ConfigShow(CurrentNum, ConfigMax(CurrentNum), ConfigType.Value) = DirectoryName.Name
                ConfigShow(CurrentNum, ConfigMax(CurrentNum), ConfigType.Text) = DirectoryName.Name
            End If
        Next
    End Sub

    Public Sub LoadConfig()
        Dim objStreamReader As StreamReader
        Dim NeedSave As Boolean = False


        If System.IO.File.Exists(AppPath & "\configV09.cfg") And Not System.IO.File.Exists(AppPath & "\" & CurrentCarFilePrefix & "configV09.cfg") Then
            System.IO.File.Copy(AppPath & "\configV09.cfg", AppPath & "\" & CurrentCarFilePrefix & "configV09.cfg")
        End If

        If System.IO.File.Exists(AppPath & "\" & CurrentCarFilePrefix & "configV09.cfg") Then
            objStreamReader = New StreamReader(AppPath & "\" & CurrentCarFilePrefix & "configV09.cfg", System.Text.Encoding.Default)
            For I = 0 To MyConfig.EndConfig - 1
                Config(I) = objStreamReader.ReadLine
                ConfigCustom(I) = Config(I)
            Next
            objStreamReader.Close()
        Else
            For I = 0 To MyConfig.EndConfig - 1
                Config(I) = ConfigShow(I, 0, ConfigType.Value)
                ConfigCustom(I) = Config(I)
            Next
            Config(MyConfig.DistanceStart) = Math.Round(Int(Val(InputBox("Please enter your odometer state for first use!", "Odometer", Math.Round(0, 0)))), 0)
            Config(MyConfig.CurrencyUnit) = System.Globalization.NumberFormatInfo.CurrentInfo.CurrencySymbol
            If System.Globalization.RegionInfo.CurrentRegion.IsMetric = True Then
                Config(MyConfig.MetricsUnit) = "km"
            Else
                Config(MyConfig.MetricsUnit) = "m"
            End If
            Config(MyConfig.FontSize) = frmFuel.Font.Size - 1
            If Math.Min(frmFuel.Width, frmFuel.Height) <= 240 Then 'And Math.Max(pctDraw.Width, pctDraw.Height) <= 320 Then
                Config(MyConfig.ScreenMultiplicator) = ScreenSizeMulti.QVGA
                Config(MyConfig.FontSize) = "8"
            Else
                Config(MyConfig.ScreenMultiplicator) = ScreenSizeMulti.VGA
                Config(MyConfig.FontSize) = "7"
            End If

            NeedSave = True
        End If

        For I = 0 To MyConfig.EndConfig - 1
            For J = 0 To ConfigMax(I)
                If Config(I) = ConfigShow(I, J, ConfigType.Value) Then
                    ConfigSelected(I) = J
                    Exit For
                ElseIf J = ConfigMax(I) Then
                    If ConfigShow(I, ConfigMax(I), ConfigType.Value) = "custom" Then
                        ConfigSelected(I) = ConfigMax(I)
                    Else
                        Config(I) = ConfigShow(I, 0, ConfigType.Value)
                        ConfigSelected(I) = 0
                        NeedSave = True
                    End If
                End If
            Next
        Next

        Call SetUpTripFix()
        If NeedSave = True Then Call SaveConfig()
    End Sub

    Public Sub SaveConfig()
        Dim objFileStream As FileStream
        Dim objStreamWriter As StreamWriter

        objFileStream = New FileStream(AppPath & "\" & CurrentCarFilePrefix & "configV09.cfg", FileMode.Create, FileAccess.Write)
        objStreamWriter = New StreamWriter(objFileStream, System.Text.Encoding.Default)

        With objStreamWriter
            For I = 0 To MyConfig.EndConfig - 1
                .WriteLine(Config(I))
            Next
            .WriteLine("---------------")
            For I = 0 To MyConfig.EndConfig - 1
                .WriteLine((I + 1) & "-" & ConfigName(I))
            Next
        End With

        objStreamWriter.Close()
        objFileStream.Close()
    End Sub

    Public Sub ConfigMenuSave()
        Dim tempConfig() As String = Config.Clone
        Dim doDrawArray() As Byte = {MyConfig.BackgroundColor, MyConfig.ForegroundColor, MyConfig.CurrencyUnit, MyConfig.FuelAmountUnit, MyConfig.MetricsUnit}
        Dim doFontResize() As Byte = {}
        Dim doRestart() As Byte = {MyConfig.CurrencyUnit, MyConfig.FuelAmountUnit, MyConfig.MetricsUnit, MyConfig.FontSize, MyConfig.ScreenMultiplicator, MyConfig.DistanceAddType, MyConfig.DistanceStart, MyConfig.LastGraphType}

        For I = 0 To MyConfig.EndConfig - 1
            If ConfigShow(I, ConfigSelected(I), ConfigType.Value) = "custom" Then
                Config(I) = ConfigCustom(I)
            Else
                Config(I) = ConfigShow(I, ConfigSelected(I), ConfigType.Value)
            End If
        Next
        Call SaveConfig()
        'Call SetUpTripFix()

        For I = 0 To doRestart.Length - 1
            If Not tempConfig(doRestart(I)) = Config(doRestart(I)) Then
                Call StartUp()
                Exit Sub
            End If
        Next
        If Not tempConfig(MyConfig.IconSet) = Config(MyConfig.IconSet) Then
            Call PreDrawIcons()
            Call PreDrawMenu()
            NeedRedraw = True
        End If

        For I = 0 To doFontResize.Length - 1
            If Not tempConfig(doFontResize(I)) = Config(doFontResize(I)) Then
                StatTextSize = BackBuffer.MeasureString(vbNewLine & vbNewLine & StatText & vbNewLine & vbNewLine & vbNewLine, frmFuel.Font)
                Exit For
            End If
        Next
        For I = 0 To doDrawArray.Length - 1
            If Not tempConfig(doDrawArray(I)) = Config(doDrawArray(I)) Then
                Call PreDraw()
                NeedRedraw = True
                Exit For
            End If
        Next

    End Sub

    Private Sub SetUpTripFix()
        If Not Config(MyConfig.DistanceAddType) = "total" Then
            TripFix = 1
        Else
            TripFix = 100
        End If
    End Sub
End Module
