﻿Module mdlScrolling
    Public CurrentPosition(MenuLoc.EndMenu) As Point
    Public SelectedItem As Integer = -1
    Public Speed As Integer
    Public tempPosTime(1) As Integer
    Public tempLastSpeedTime As Single

    Public Sub GetSpeed(ByVal OldMousePosition As Single, ByVal NewMousePosition As Single)
        tempPosTime(1) = tempPosTime(0)
        tempPosTime(0) = System.Environment.TickCount
        If tempPosTime(0) > tempPosTime(1) Then
StartSpeed:
            Speed = (NewMousePosition - OldMousePosition) / (tempPosTime(0) - tempPosTime(1)) * 1000 * 2.1
            'Speed formular from physics: Speed = (Distrance)/(Time), or short v=s/t
            'Just * 1000 for pixel per second
        ElseIf tempPosTime(0) = tempPosTime(1) Then
            Speed = 0
        ElseIf tempPosTime(0) < tempPosTime(1) Then
            tempPosTime(0) = Int32.MinValue + (Int32.MaxValue - tempPosTime(1)) + tempPosTime(0)
            tempPosTime(1) = Int32.MinValue
            GoTo StartSpeed
            'This happens once 49.8 days because it switches at Int32.MaxValue to Int32.MinValue
            'Should be working
        End If
        DebugString = tempPosTime(0) - tempPosTime(1) & vbNewLine & NewMousePosition - OldMousePosition & vbNewLine ' & (Speed)
        'I removed it and added the speed at drawtime because it can change during scrolling when it hits "the wall"
        NeedRedraw = True
    End Sub

    Public Sub KeepMoving()
        If Speed <> 0 Then
            If System.Environment.TickCount > tempLastSpeedTime Then
                CurrentPosition(CurrentLocation).Y += (Speed / 1000) * (System.Environment.TickCount - tempLastSpeedTime)
                'phyisics again: Distance = Speed * Time, or short s=v*t
                If Math.Abs(Speed) > 500 Then
                    Speed = Speed - (Speed / 10)
                ElseIf Math.Abs(Speed) > 100 Then
                    Speed = Speed - (Speed / 20)
                ElseIf Math.Abs(Speed) > 25 Then
                    Speed = Speed - (Speed / 16)
                ElseIf Math.Abs(Speed) > 12 Then
                    Speed = Speed - (Speed / 8)
                Else
                    Speed = Speed - (Speed / 3)
                End If
                Speed = Speed - Math.Sign(Speed) * 5

                If CurrentPosition(CurrentLocation).Y > 0 Then
                    Speed = 0
                    CurrentPosition(CurrentLocation).Y = 0
                ElseIf CurrentPosition(CurrentLocation).Y < (-(ItemMax(CurrentLocation) + 1) * ObjectHeight(CurrentLocation) + InnerDrawSize.Height) Then
                    Speed = 0
                    If (ItemMax(CurrentLocation) + 1) * ObjectHeight(CurrentLocation) > InnerDrawSize.Height Then
                        CurrentPosition(CurrentLocation).Y = -(ItemMax(CurrentLocation) + 1) * ObjectHeight(CurrentLocation) + InnerDrawSize.Height
                    Else
                        CurrentPosition(CurrentLocation).Y = 0
                    End If
                End If
                    'Just check if it hits "the wall"
                    NeedRedraw = True
            ElseIf System.Environment.TickCount < tempLastSpeedTime Then
                'No high priority to fix, if it happens just one short stop
                'This happens once 49.8 days because it switches at Int32.MaxValue to Int32.MinValue
            End If
        End If
    End Sub
End Module
